-- Greg Stitt
-- University of Florida
-- EEL 5934/4930 Reconfigurable Computing
--
-- File: reg.vhd
--
-- Description: This file implements a register with load enable.
--

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_UNSIGNED.all;

entity REG is
  generic (width    :     natural := 32);
  port(clk, rst, en : in  std_logic;
       input        : in  unsigned(width-1 downto 0);
       output       : out unsigned(width-1 downto 0));
end REG;

architecture bhv of REG is
begin
  process(clk, rst)
  begin
    if rst = '1' then
      output   <= conv_unsigned(0, width);
    elsif (clk = '1' and clk'event) then
      if (en = '1') then
        output <= input;
      end if;
    end if;
  end process;
end bhv;
